/*
 * emu68k.h
 *
 * emulation of the 68000
 */

/* $Id: emu68k.h,v 1.3 2000/01/14 04:40:16 nyef Exp $ */

#ifndef EMU68K_H
#define EMU68K_H

struct emu68k_context {
    unsigned long regs_a[8];
    unsigned long regs_d[8];
    unsigned long other_sp;
    unsigned long pc;
    unsigned short flags;
    int cycles_left;
    memread8_t *read8table;
    memwrite8_t *write8table;
    memread16_t *read16table;
    memwrite16_t *write16table;
    int memshift;
    unsigned long memmask;
    cal_cpu cpu;
};

void emu68k_step(struct emu68k_context *context);
void emu68k_run(struct emu68k_context *context);
void emu68k_reset(struct emu68k_context *context);

#endif /* EMU68K_H */

/*
 * $Log: emu68k.h,v $
 * Revision 1.3  2000/01/14 04:40:16  nyef
 * added prototype for emu68k_run() (for cycle-counted operation)
 *
 * Revision 1.2  1999/12/12 17:38:48  nyef
 * added support for cycle counting
 *
 * Revision 1.1  1999/04/17 22:24:58  nyef
 * Initial revision
 *
 */
