/*
 * nes_psg.h
 *
 * NES sound emulation
 */

/* $Id: nes_psg.h,v 1.4 1999/02/14 18:28:18 nyef Exp $ */

#ifndef __NES_PSG_H__
#define __NES_PSG_H__


void nes_psg_enter_cpu(long cycles_left);
void nes_psg_leave_cpu(long cycles_left);

void nes_psg_init(void);
void nes_psg_done(void);

void nes_psg_vsync(void);

typedef void (*psg_writefunc)(cal_cpu cpu, unsigned short addr, unsigned char value);

psg_writefunc sound_regs[16];

void nes_psg_write_control(cal_cpu cpu, unsigned short addr, unsigned char value);

/*
 * nes_psg_quality is used to control the sound playback rate.
 * anything < 1 disables sound.
 * 1 is 22050 Hz.
 * 2 is 44100 Hz.
 * anything > 2 is 44100 Hz.
 * these values subject to change without notice.
 */
extern int nes_psg_quality;


#endif /* __NES_PSG_H__ */

/*
 * $Log: nes_psg.h,v $
 * Revision 1.4  1999/02/14 18:28:18  nyef
 * added a function pointer array for writing the sound regs
 * added a function prototype for writing the control reg
 *
 * Revision 1.3  1998/12/06 04:18:22  nyef
 * added preliminary sound quality (playback rate) support.
 *
 * Revision 1.2  1998/08/30 20:36:42  nyef
 * added vsync hook procedure.
 *
 * Revision 1.1  1998/08/22 00:24:40  nyef
 * Initial revision
 *
 */
