/*
 * pce_vdp.h
 *
 * HuC6270/HuC6260 emulation.
 */

#ifndef PCE_VDP_H
#define PCE_VDP_H

/* $Id: pce_vdp.h,v 1.6 1999/05/23 15:19:32 nyef Exp $ */

typedef struct pce_vdp *pce_vdp;

typedef unsigned char (*portread_t)(pce_vdp, unsigned short);
typedef void (*portwrite_t)(pce_vdp, unsigned short, unsigned char);
typedef int (*periodic_t)(pce_vdp);

struct pce_vdp {
    portread_t readvdp;
    portwrite_t writevdp;
    portread_t readvce;
    portwrite_t writevce;
    periodic_t periodic;

    unsigned char flags;
    unsigned char status;
    unsigned char cur_reg;
    unsigned char *memory;
    unsigned short mem_read_addr;
    unsigned short mem_write_addr;
    unsigned char regs_l[32];
    unsigned char regs_h[32];
    unsigned char last_width;
    unsigned short last_height;
    unsigned short palette_addr;
    unsigned char palette_l[512];
    unsigned char palette_h[512];
    unsigned char palette_xlat[512];
    unsigned short cur_scanline;
    unsigned short y_scroll;
};

pce_vdp pce_vdp_create(void);

#endif /* PCE_VDP_H */

/*
 * $Log: pce_vdp.h,v $
 * Revision 1.6  1999/05/23 15:19:32  nyef
 * fixed some v-scroll problems
 *
 * Revision 1.5  1999/03/03 02:47:03  nyef
 * added hooks for resolution control to struct pce_vdp
 *
 * Revision 1.4  1999/01/31 01:04:07  nyef
 * fixed palette_xlat array to be the correct size
 *
 * Revision 1.3  1999/01/31 00:16:14  nyef
 * added preliminary implimentation of palette ram
 *
 * Revision 1.2  1999/01/30 23:09:44  nyef
 * redesigned VDP I/O interface.
 *
 * Revision 1.1  1999/01/17 02:12:51  nyef
 * Initial revision
 *
 */
